/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package launcher

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Launcher struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Visible *dbusPropertyLauncherVisible
}

func (obj *Launcher) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Launcher) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroyLauncher(obj *Launcher) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='PropertiesChanged'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='Closed'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='Shown'")

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='VisibleChanged'")

	obj.Visible.Reset()
}

func (obj *Launcher) Exit() (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.Exit", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) Hide() (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.Hide", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) Show() (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.Show", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) ShowByMode(in0 int64) (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.ShowByMode", 0, in0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) UninstallApp(appKey string) (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.UninstallApp", 0, appKey).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) Toggle() (_err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.Toggle", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) IsVisible() (arg0 bool, _err error) {
	_err = obj.core.Call("com.deepin.dde.Launcher.IsVisible", 0).Store(&arg0)
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Launcher) ConnectClosed(callback func()) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.dde.Launcher.Closed" || 0 != len(v.Body) {
				continue
			}

			callback()
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *Launcher) ConnectShown(callback func()) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.dde.Launcher.Shown" || 0 != len(v.Body) {
				continue
			}

			callback()
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

func (obj *Launcher) ConnectVisibleChanged(callback func(visible bool)) func() {
	sigChan := obj._createSignalChan()
	go func() {
		for v := range sigChan {
			if v.Path != obj.Path || v.Name != "com.deepin.dde.Launcher.VisibleChanged" || 1 != len(v.Body) {
				continue
			}
			if reflect.TypeOf(v.Body[0]) != reflect.TypeOf((*bool)(nil)).Elem() {
				continue
			}

			callback(v.Body[0].(bool))
		}
	}()
	return func() {
		obj._deleteSignalChan(sigChan)
	}
}

type dbusPropertyLauncherVisible struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertyLauncherVisible) SetValue(notwritable interface{}) {
	fmt.Println("com.deepin.dde.Launcher.Visible is not writable")
}

func (this *dbusPropertyLauncherVisible) Get() bool {
	v, _ := this.GetValue()
	return v.(bool)
}
func (this *dbusPropertyLauncherVisible) GetValue() (interface{} /*bool*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "com.deepin.dde.Launcher", "Visible").Store(&r)
	if err == nil && r.Signature().String() == "b" {
		return r.Value().(bool), nil
	}
	return *new(bool), err
}
func (this *dbusPropertyLauncherVisible) GetType() reflect.Type {
	return reflect.TypeOf((*bool)(nil)).Elem()
}

func NewLauncher(destName string, path dbus.ObjectPath) (*Launcher, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Launcher{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Visible = &dbusPropertyLauncherVisible{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='com.deepin.dde.Launcher',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "com.deepin.dde.Launcher" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Visible" {
						obj.Visible.Notify()
					}
				}
			} else if v.Name == "com.deepin.dde.Launcher.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Visible" {
						obj.Visible.Notify()
					}
				}
			}
		}
	}()

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='Closed'")

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='Shown'")

	dbusAddMatch("type='signal',path='" + string(obj.Path) + "',interface='com.deepin.dde.Launcher',sender='" + obj.DestName + "',member='VisibleChanged'")

	runtime.SetFinalizer(obj, func(_obj *Launcher) { DestroyLauncher(_obj) })
	return obj, nil
}
