/*This file is automatically generated by pkg.deepin.io/dbus-generator. Don't edit it*/
package wfd

import "pkg.deepin.io/lib/dbus"
import "pkg.deepin.io/lib/dbus/property"
import "reflect"
import "sync"
import "runtime"
import "fmt"
import "errors"

/*prevent compile error*/
var _ = fmt.Println
var _ = runtime.SetFinalizer
var _ = sync.NewCond
var _ = reflect.TypeOf
var _ = property.BaseObserver{}

type Session struct {
	Path     dbus.ObjectPath
	DestName string
	core     *dbus.Object

	signals       map[<-chan *dbus.Signal]struct{}
	signalsLocker sync.Mutex

	Sink  *dbusPropertySessionSink
	Url   *dbusPropertySessionUrl
	State *dbusPropertySessionState
}

func (obj *Session) _createSignalChan() <-chan *dbus.Signal {
	obj.signalsLocker.Lock()
	ch := getBus().Signal()
	obj.signals[ch] = struct{}{}
	obj.signalsLocker.Unlock()
	return ch
}
func (obj *Session) _deleteSignalChan(ch <-chan *dbus.Signal) {
	obj.signalsLocker.Lock()
	delete(obj.signals, ch)
	getBus().DetachSignal(ch)
	obj.signalsLocker.Unlock()
}
func DestroySession(obj *Session) {
	obj.signalsLocker.Lock()
	defer obj.signalsLocker.Unlock()
	if obj.signals == nil {
		return
	}
	for ch, _ := range obj.signals {
		getBus().DetachSignal(ch)
	}
	obj.signals = nil

	runtime.SetFinalizer(obj, nil)

	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.DBus.Properties',sender='" + obj.DestName + "',member='PropertiesChanged'")
	dbusRemoveMatch("type='signal',path='" + string(obj.Path) + "',interface='org.freedesktop.miracle.wfd.Session',sender='" + obj.DestName + "',member='PropertiesChanged'")

	obj.Sink.Reset()
	obj.Url.Reset()
	obj.State.Reset()
}

func (obj *Session) Resume() (_err error) {
	_err = obj.core.Call("org.freedesktop.miracle.wfd.Session.Resume", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Session) Pause() (_err error) {
	_err = obj.core.Call("org.freedesktop.miracle.wfd.Session.Pause", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

func (obj *Session) Teardown() (_err error) {
	_err = obj.core.Call("org.freedesktop.miracle.wfd.Session.Teardown", 0).Store()
	if _err != nil {
		fmt.Println(_err)
	}
	return
}

type dbusPropertySessionSink struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySessionSink) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.miracle.wfd.Session.Sink is not writable")
}

func (this *dbusPropertySessionSink) Get() dbus.ObjectPath {
	v, _ := this.GetValue()
	return v.(dbus.ObjectPath)
}
func (this *dbusPropertySessionSink) GetValue() (interface{} /*dbus.ObjectPath*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.miracle.wfd.Session", "Sink").Store(&r)
	if err == nil && r.Signature().String() == "o" {
		return r.Value().(dbus.ObjectPath), nil
	}
	return *new(dbus.ObjectPath), err
}
func (this *dbusPropertySessionSink) GetType() reflect.Type {
	return reflect.TypeOf((*dbus.ObjectPath)(nil)).Elem()
}

type dbusPropertySessionUrl struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySessionUrl) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.miracle.wfd.Session.Url is not writable")
}

func (this *dbusPropertySessionUrl) Get() string {
	v, _ := this.GetValue()
	return v.(string)
}
func (this *dbusPropertySessionUrl) GetValue() (interface{} /*string*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.miracle.wfd.Session", "Url").Store(&r)
	if err == nil && r.Signature().String() == "s" {
		return r.Value().(string), nil
	}
	return *new(string), err
}
func (this *dbusPropertySessionUrl) GetType() reflect.Type {
	return reflect.TypeOf((*string)(nil)).Elem()
}

type dbusPropertySessionState struct {
	*property.BaseObserver
	core *dbus.Object
}

func (this *dbusPropertySessionState) SetValue(notwritable interface{}) {
	fmt.Println("org.freedesktop.miracle.wfd.Session.State is not writable")
}

func (this *dbusPropertySessionState) Get() int32 {
	v, _ := this.GetValue()
	return v.(int32)
}
func (this *dbusPropertySessionState) GetValue() (interface{} /*int32*/, error) {
	var r dbus.Variant
	err := this.core.Call("org.freedesktop.DBus.Properties.Get", 0, "org.freedesktop.miracle.wfd.Session", "State").Store(&r)
	if err == nil && r.Signature().String() == "i" {
		return r.Value().(int32), nil
	}
	return *new(int32), err
}
func (this *dbusPropertySessionState) GetType() reflect.Type {
	return reflect.TypeOf((*int32)(nil)).Elem()
}

func NewSession(destName string, path dbus.ObjectPath) (*Session, error) {
	if !path.IsValid() {
		return nil, errors.New("The path of '" + string(path) + "' is invalid.")
	}

	core := getBus().Object(destName, path)

	obj := &Session{Path: path, DestName: destName, core: core, signals: make(map[<-chan *dbus.Signal]struct{})}

	obj.Sink = &dbusPropertySessionSink{&property.BaseObserver{}, core}
	obj.Url = &dbusPropertySessionUrl{&property.BaseObserver{}, core}
	obj.State = &dbusPropertySessionState{&property.BaseObserver{}, core}

	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.DBus.Properties',sender='" + destName + "',member='PropertiesChanged'")
	dbusAddMatch("type='signal',path='" + string(path) + "',interface='org.freedesktop.miracle.wfd.Session',sender='" + destName + "',member='PropertiesChanged'")
	sigChan := obj._createSignalChan()
	go func() {
		typeString := reflect.TypeOf("")
		typeKeyValues := reflect.TypeOf(map[string]dbus.Variant{})
		typeArrayValues := reflect.TypeOf([]string{})
		for v := range sigChan {
			if v.Name == "org.freedesktop.DBus.Properties.PropertiesChanged" &&
				len(v.Body) == 3 &&
				reflect.TypeOf(v.Body[0]) == typeString &&
				reflect.TypeOf(v.Body[1]) == typeKeyValues &&
				reflect.TypeOf(v.Body[2]) == typeArrayValues &&
				v.Body[0].(string) == "org.freedesktop.miracle.wfd.Session" {
				props := v.Body[1].(map[string]dbus.Variant)
				for key, _ := range props {
					if false {
					} else if key == "Sink" {
						obj.Sink.Notify()

					} else if key == "Url" {
						obj.Url.Notify()

					} else if key == "State" {
						obj.State.Notify()
					}
				}
			} else if v.Name == "org.freedesktop.miracle.wfd.Session.PropertiesChanged" && len(v.Body) == 1 && reflect.TypeOf(v.Body[0]) == typeKeyValues {
				for key, _ := range v.Body[0].(map[string]dbus.Variant) {
					if false {
					} else if key == "Sink" {
						obj.Sink.Notify()

					} else if key == "Url" {
						obj.Url.Notify()

					} else if key == "State" {
						obj.State.Notify()
					}
				}
			}
		}
	}()

	runtime.SetFinalizer(obj, func(_obj *Session) { DestroySession(_obj) })
	return obj, nil
}
